VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl ctrlDropDownListView 
   ClientHeight    =   1065
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7005
   ScaleHeight     =   1065
   ScaleWidth      =   7005
   Begin VB.CommandButton cmdDrop 
      Height          =   240
      Left            =   4725
      Picture         =   "ctrlDropDownListView.ctx":0000
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   45
      Width           =   240
   End
   Begin MSComctlLib.ListView lstChoice 
      Height          =   330
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5010
      _ExtentX        =   8837
      _ExtentY        =   582
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "ctrlDropDownListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Private Declare Sub CoCreateGuid Lib "ole32.dll" (ByRef pguid As Any)

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const SWP_ASYNCWINDOWPOS = &H4000
Private Const SWP_DEFERERASE = &H2000
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Private Const SWP_NOSENDCHANGING = &H400
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_SHOWWINDOW = &H40

Private WithEvents DropFrm As frmDrop
Attribute DropFrm.VB_VarHelpID = -1

Private This As Object
Private MyID As String


Public Property Get ID() As String
    If Len(MyID) = 0 Then MyID = CreateGUID
    
    ID = MyID
End Property

Public Property Let ID(ByVal vNewValue As String)

End Property

Private Function CreateGUID() As String
    Dim NewGUID(15) As Byte, K As Long
    
    CoCreateGuid NewGUID(0)
    
    CreateGUID = "{"
    For K = 0 To 15
        CreateGUID = CreateGUID & Right("0" & Hex(NewGUID(K)), 2)
        
        Select Case K
        Case 4, 6, 8, 10
            CreateGUID = CreateGUID & "-"
        End Select
    Next K
    
    CreateGUID = CreateGUID & "}"
End Function

Private Sub FindMe()
    Dim K As Long
    
    If This Is Nothing Then
        For K = 0 To UserControl.Parent.Controls.Count - 1
            If TypeName(UserControl.Parent.Controls(K)) = "ctrlDropDownListView" Then
                If UserControl.Parent.Controls(K).ID = Me.ID Then
                    Set This = UserControl.Parent.Controls(K)
                    
                    Exit For
                End If
            End If
        Next K
        
        If K = UserControl.Parent.Controls.Count Then Exit Sub
        
        'Debug.Print "This is: " & This.Name
    End If
End Sub

Private Sub cmdDrop_Click()
    Dim CtrlRect As RECT, Par As RECT
    
    If Not DropFrm.Visible Then
        FindMe
        
        If Not (This Is Nothing) Then
            SetParent DropFrm.hwnd, UserControl.Parent.hwnd
            
            GetWindowRect UserControl.Parent.hwnd, Par
            GetWindowRect UserControl.hwnd, CtrlRect
            
            SetWindowPos DropFrm.hwnd, 0, CtrlRect.Left - Par.Left - 4, CtrlRect.Top - Par.Top - 4, 0, 0, SWP_NOSIZE
            
            DropFrm.Visible = True
            UserControl.SetFocus
        End If
    Else
        DropFrm.Visible = False
        
        DoEvents
        This.SetFocus
        UserControl.SetFocus
        UserControl.Parent.SetFocus
    End If
End Sub

Private Sub cmdDrop_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl.SetFocus
End Sub

Private Sub DropFrm_frmItemClick(ByVal Item As MSComctlLib.ListItem)
    Dim K As Long, LI As ListItem
    
    DropFrm.Visible = False
    
    Do Until lstChoice.ListItems.Count = 0
        lstChoice.ListItems.Remove 1
    Loop
    
    Set LI = lstChoice.ListItems.Add(, , Item.Text)
    For K = 1 To lstChoice.ColumnHeaders.Count - 1
        LI.SubItems(K) = Item.SubItems(K)
    Next K
End Sub

Private Sub lstChoice_BeforeLabelEdit(Cancel As Integer)
    Cancel = 1
End Sub

Private Sub lstChoice_Click()
    cmdDrop_Click
End Sub

Private Sub UserControl_Initialize()
    Set DropFrm = New frmDrop
End Sub

Private Sub UserControl_LostFocus()
    DropFrm.Visible = False
End Sub

Private Sub UserControl_Resize()
    Dim FntSize As Single
    
    Set UserControl.Font = lstChoice.Font
    FntSize = UserControl.TextHeight("A")
    
    If UserControl.Height > FntSize + 90 + 30 Then
        UserControl.Height = FntSize + 90 + 30
    End If
    
    lstChoice.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    cmdDrop.Move UserControl.ScaleWidth - cmdDrop.Width - 45, 45
    cmdDrop.Height = UserControl.ScaleHeight - 90
    
    If Not (DropFrm Is Nothing) Then
        DropFrm.Width = UserControl.Width
    End If
End Sub

Private Sub UserControl_Terminate()
    Unload DropFrm
    Set DropFrm = Nothing
End Sub

Public Property Get Columns() As Long
    Columns = lstChoice.ColumnHeaders.Count
End Property

Public Property Let Columns(ByVal vNewValue As Long)
    Dim K As Long
    
    If lstChoice.ColumnHeaders.Count = 0 Then
        For K = 1 To vNewValue
            lstChoice.ColumnHeaders.Add , , Chr(64 + K)
            DropFrm.lstListData.ColumnHeaders.Add , , Chr(64 + K)
        Next K
    Else
        
    End If
End Property

Public Property Get ListItems() As IListItems
    Set ListItems = DropFrm.lstListData.ListItems
End Property

Public Property Let ListItems(ByVal vNewValue As IListItems)

End Property
